# ESSVideoShare.framework for OS X Lion and iOS ReadMe

## What is ESSVideoShare.framework?

ESSVideoShare.framework makes it very easy and quick to add uploading functionality for videos to these services:  
[YouTube](http://www.youtube.com), [Vimeo](http://www.vimeo.com), [Facebook](http://www.facebook.com) and [Flickr](http://www.flickr.com).

It was inspired by QuickTime Player X's sharing functionality.

## First, the License Agreement

1) You can use the code in your own products.  
2) You can modify the code as you wish, and use the modified code in your products.  
3) You can redistribute the original, unmodified code, but you have to include the full license text below.  
4) You can redistribute the modified code as you wish (without the full license text below).  
5) In all cases, you must include a credit mentioning Matthias Gansrigler as the original author of the source.  
6) I’m not liable for anything you do with the code, no matter what. So be sensible.  
7) You can’t use my name or other marks to promote your products based on the code.  
8) This framework uses the OAuthConsumer framework code which you can separately download from http://code.google.com/p/oauthconsumer/ which is made available under the MIT License.  
9) If you agree to all of that, go ahead and download the source. Otherwise, don’t.

# How To use ESSVideoShare

Please be aware that the sample projects might not have the newest ESSVideoShare framework imported.)

[OS X Lion (Wiki)](https://github.com/eternalstorms/ESSVideoShare-for-OS-X-Lion/wiki/How-To-for-OS-X-Lion) ([Sample Project for OS X Lion, ~250 KB](http://eternalstorms.at/opensource/ESSVideoShare/esvideosharetestMac.zip))

[iOS (Wiki)](https://github.com/eternalstorms/ESSVideoShare-for-OS-X-Lion/wiki/How-To-for-iOS) ([Sample Project for iOS, ~3 MB](http://eternalstorms.at/opensource/ESSVideoShare/essvideoshareios.zip))

# ESSVideoShare in Action

## ESSYouTube

![Login](http://www.eternalstorms.at/opensource/ESSVideoShare/youtube/1.png "Login")  
![Meta Data](http://www.eternalstorms.at/opensource/ESSVideoShare/youtube/2.png "Movie meta data")  
![Terms of Use](http://www.eternalstorms.at/opensource/ESSVideoShare/youtube/3.png "Terms of Use")  
![Upload Progress](http://www.eternalstorms.at/opensource/ESSVideoShare/youtube/4.png "Upload progress")  
![Waiting For Processing](http://www.eternalstorms.at/opensource/ESSVideoShare/youtube/5.png "Waiting for Processing")  
![Done](http://www.eternalstorms.at/opensource/ESSVideoShare/youtube/6.png "Done")  

## ESSVimeo

![Login](http://www.eternalstorms.at/opensource/ESSVideoShare/vimeo/1.png "Login")  
![Meta Data](http://www.eternalstorms.at/opensource/ESSVideoShare/vimeo/2.png "Movie meta data")  
![Terms of Use](http://www.eternalstorms.at/opensource/ESSVideoShare/vimeo/3.png "Terms of Use")  
![Upload Progress](http://www.eternalstorms.at/opensource/ESSVideoShare/vimeo/4.png "Upload progress")  
![Done](http://www.eternalstorms.at/opensource/ESSVideoShare/vimeo/5.png "Done")  

## ESSFacebook

![Login](http://www.eternalstorms.at/opensource/ESSVideoShare/facebook/0.png "Login")  
![Confirm Login](http://www.eternalstorms.at/opensource/ESSVideoShare/facebook/2.png "Confirm Login")  
![Movie Metadata](http://www.eternalstorms.at/opensource/ESSVideoShare/facebook/3.png "Movie metadata")  
![Upload Progress](http://www.eternalstorms.at/opensource/ESSVideoShare/facebook/4.png "Upload progress")  
![Done](http://www.eternalstorms.at/opensource/ESSVideoShare/facebook/5.png "Done")  

## ESSFlickr

![Login](http://www.eternalstorms.at/opensource/ESSVideoShare/flickr/1.png "Login")  
![Movie metadata](http://www.eternalstorms.at/opensource/ESSVideoShare/flickr/2.png "Movie metadata")  
![Upload Progress](http://www.eternalstorms.at/opensource/ESSVideoShare/flickr/3.png "Movie metadata")  
![Waiting for Processing](http://www.eternalstorms.at/opensource/ESSVideoShare/flickr/4.png "Waiting for Processing")  
![Done](http://www.eternalstorms.at/opensource/ESSVideoShare/flickr/5.png "Done")

## Requirements
This code works on OS X Lion and later.  
Developed with Xcode 4.2.1  

## External Frameworks / Source Code used

OAuthConsumer framework (http://code.google.com/p/oauthconsumer/ , made available under the MIT License)

## Support
The framework and code is provided as-is, but if you need help or have suggestions, you can contact me anytime at [opensource@eternalstorms.at](mailto:opensource@eternalstorms.at) or [@eternalstorms on twitter](http://twitter.com/eternalstorms)

For other Open Source projects of mine, please visit http://www.eternalstorms.at/opensource

# I want to hear from you
If you use ESSVideoShare in one of your projects, please [let me know](mailto:opensource@eternalstorms.at)! I'd love to hear about your apps and mention them here on this project page :) !!